-- mux.vhd
-- Lab 5
-- Team CART
-- CSE 132L
-- This is a 3-to-1 multiplexer, with a generic width for the output and
-- inputs to make the bus size adjustable for each instance.

LIBRARY ieee;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_1164.ALL;
USE work.lab5_pack.ALL;

ENTITY mux3 IS
PORT (
	s : IN  std_logic_vector (1      DOWNTO 0);
	a :	IN  std_logic_vector (NBIT-1 DOWNTO 0);
	b :	IN  std_logic_vector (NBIT-1 DOWNTO 0);
	c : IN  std_logic_vector (NBIT-1 DOWNTO 0);
	o :	OUT std_logic_vector (NBIT-1 DOWNTO 0) 	
);
END mux3;

ARCHITECTURE Behavioral OF mux3 IS

	SIGNAL e : std_logic_vector (NBIT-1 DOWNTO 0) := (OTHERS => 'X');

BEGIN

	WITH s SELECT o <= 
		a WHEN "00", 
		b WHEN "01",
		c WHEN "10", 
		e WHEN OTHERS;

END Behavioral;

