-- lab2_pack.vhd
-- Lab 2
-- Team CART
-- CSE 132L
-- This package defines constants for the various bit widths used in the
-- components of the processor. This makes the design more uniform and eases
-- the modification of bit widths used in the blocks.
library ieee;
use ieee.std_logic_1164.all;

package lab2_pack is

constant NBIT : integer := 32;	-- the width of memory, instructions, etc.
constant NALU : integer := 6;	-- the number of bits expected in an ALU function code
constant NIMM : integer := 16;	-- the number of bits in the immediate field
constant NMEM : integer := 9;	-- the number of bits needed to select a word in memory 
constant NOPC : integer := 6;	-- the number of bits expected in an opcode
constant NREG : integer := 5;	-- the number of bits needed to select a register

end;
