-- ram.vhd
-- Lab 2
-- Team CART
-- CSE 132L
-- The RAM block is used for the data memory. It has an address port
-- for the read and write addresses, a port for read data, a port for
-- write data, a write enable signal, and a clock input. The write
-- operates synchronously, while the read operates asynchronously.
-- The RAM is of size 512x32 bits.
LIBRARY ieee;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_1164.ALL;
use work.lab2_pack.all;

ENTITY ram IS
	PORT (
		clk : 	IN std_logic;
		we : 	IN std_logic;
		addr : 	IN std_logic_vector (NMEM-1 DOWNTO 0);
		dataI : IN std_logic_vector (NBIT-1 DOWNTO 0);
		dataO : OUT std_logic_vector (NBIT-1 DOWNTO 0)
	);
END ram;

ARCHITECTURE Behavioral OF ram IS

	TYPE mem_array IS ARRAY ((2**NMEM)-1 DOWNTO 0) OF std_logic_vector (NBIT-1 DOWNTO 0);
	SIGNAL memory : mem_array := (others => (others => '0'));

BEGIN

	do_ram_things: PROCESS(clk)
	BEGIN
		-- If the clock has changed state and is on the rising edge
		IF (clk = '1') THEN  
			-- If write enabled is HIGH, write input to memory 
			IF (we = '1') THEN
				memory(to_integer(unsigned(addr))) <= dataI;
			END IF;	
		END IF;    

	END PROCESS;
	
	-- Read data from memory
	dataO <= memory(to_integer(unsigned(addr)));

END Behavioral;

