module ram_tb();

	/* local declaration */
	logic clk;
	logic we;
	logic[8:0]	addr;
	logic[31:0]	dataI;

	wire[31:0]	dataO;
  
	/* instantiate a RAM module */
	ram R1(
		.clk(clk),
		.we(we),
		.addr(addr),
		.dataI(dataI),
		.dataO(dataO)
	);

always 
begin
	clk = 1'b1;	#5;
	clk = 1'b0;	#5;	
end

initial 
begin
	/* read the data at location 0 */
	we = 1'b0;
	addr = 9'd0;
	#10;

	/* write 1 to location 0 */
	we = 1'b1;
	dataI = 32'd1;
	#10;

	/* write 4294967295 to location 1 */
	dataI = 32'd4294967295;
	addr = 9'd1;
	#10;

	/* read the data at location 0 */
	addr = 9'd0;
	we = 1'b0;
	#10;

	/* read the data at location 1 */
	addr = 9'd1;
	#10;	

	$finish;
end

endmodule
    
