#! /bin/csh -f
#
# CSE 132L - Team CART
# This script will automatically run perform all necessary steps
# for setting up the environment, compiling design and testbench
# files, optimizing the testbench, and simulating the design.
# This script will run the testbench for the processor, but not
# the testbenches for any of the individual blocks.
# Assumptions:
# 	The file rtl.cfg contains the list of all the design files
# 	rtl.cfg does not need to contain the header file
# 	This script is for use with QuestaSim on the EECS servers

source setup.csh
source pre_compile.csh

vcom -64 lab3_pack.vhd
vcom -64 -f rtl.cfg -l compilation_design.log

vlog -64 -sv processor_tb.sv -l compilation_testbench.log

vopt -64 processor_tb +acc=mpr -o processor_tb_opt -l optimization.log

vsim -64 -l simulation.log -do sim.do -c processor_tb_opt
