#! /bin/csh -f
#
# This script is used to run the process of compilation, elaboration
# and simulation for one component. To use this script, run the script
# in the following way:
#
# csh run_component.csh <name_of_component>
#
# where <name_of_component> is the name of the component under test.
# Assumptions:
#   The design file for the component is named <name_of_component>.vhd
#   The testbench file for the component is named <name_of_component>_tb.sv
#   Both the design and testbench file are in the same directory as this script
#   The sim.do file has the name of the testbench for the unit under test

if ($#argv != 1) then
	echo "Usage: csh run_component.csh <name_of_component>"
	exit 0
endif

source setup.csh
source pre_compile.csh

set component=$1

vcom -64 lab3_pack.vhd
vcom -64 ${component}.vhd
vlog -64 -sv ${component}_tb.sv

vopt -64 ${component}_tb +acc=mpr -o ${component}_tb_opt

vsim -64 -l simulation.log -do sim.do -c ${component}_tb_opt

vsim -view waveform.wlf
