-- alu.vhd
-- Lab 2
-- Team CART
-- CSE 132L
-- The ALU block can perform arithmetic and logic operations
-- on two operands, each of width 32 bits. It can also compare
-- them for equality, for use with branch instructions, but
-- that feature is not included for this lab.
-- The following operations are supported by this versino of the
-- ALU: add, addu, sub, subu, and, or, xor, nor, slt, sltu
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.lab2_pack.all;

ENTITY alu IS
    PORT (
        Func_in : IN std_logic_vector (NALU-1 DOWNTO 0);
        A_in : IN std_logic_vector (NBIT-1 DOWNTO 0);
        B_in : IN std_logic_vector (NBIT-1 DOWNTO 0);
        O_out : OUT std_logic_vector (NBIT-1 DOWNTO 0);
        Branch_out : OUT std_logic;
        Jump_out : OUT std_logic
    );
END alu;

architecture Behavioral of alu is

signal add_signed, add_unsigned, sub_signed, sub_unsigned, logic_and, logic_or, logic_xor, logic_nor, slt_signed, slt_unsigned : STD_LOGIC_VECTOR (31 downto 0);

begin
	process (Func_in, A_in, B_in)
	begin
	    add_signed <= std_logic_vector(signed(A_in) + signed(B_in));
	    add_unsigned <= std_logic_vector(unsigned(A_in) + unsigned(B_in));
	    sub_signed <= std_logic_vector(signed(A_in) - signed(B_in));
	    sub_unsigned <= std_logic_vector(unsigned(A_in) - unsigned(B_in));
    
	    logic_and <= A_in AND B_in;
	    logic_or <= A_in OR B_in;
	    logic_xor <= A_in XOR B_in;
	    logic_nor <= A_in NOR B_in;
	end process;
	
 
	    slt_signed <= "11111111111111111111111111111111"  when signed(A_in) < signed(B_in) else "00000000000000000000000000000000";
	    slt_unsigned <= "11111111111111111111111111111111" when unsigned(A_in) < unsigned(B_in) else "00000000000000000000000000000000";
    
	    with Func_in select
	        O_out <= add_signed when "100000",
	                 add_unsigned when "100001",
	                 sub_signed when "100010",
	                 sub_unsigned when "100011",
	                 logic_and when "100100",
	                 logic_or when "100101",
	                 logic_xor when "100110",
	                 logic_nor when "100111",
	                 slt_signed when "101000",
	                 slt_unsigned when "101001",
	                 (others => '0') when others;
                    
	    Branch_out <= '0';
	    Jump_out <= '0';
    
end Behavioral;
