library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use work.lab5_pack.all;

entity memory_writeback_reg is
port (
    clk : in std_logic;
    rst : in std_logic;
    RegWriteM : in std_logic;
    MemtoRegM : in std_logic;
    ALUOutM : in std_logic_vector(NBIT-1 downto 0);
    ReadDataM : in std_logic_vector(NBIT-1 downto 0);
    WriteRegM : in std_logic_vector(NREG-1 downto 0);
    RegWriteW : out std_logic;
    MemtoRegW : out std_logic;
    ALUOutW : out std_logic_vector(NBIT-1 downto 0);
    ReadDataW : out std_logic_vector(NBIT-1 downto 0);
    WriteRegW : out std_logic_vector(NREG-1 downto 0)

    );
end memory_writeback_reg;

architecture Behavioral of memory_writeback_reg is
begin
    Process (clk)
    begin
        if (clk'event and clk = '1') then
            if rst = '1' then
                RegWriteW <= '0';
                MemtoRegW <= '0';
                ALUOutW <= (others => '0');
                ReadDataW <= (others => '0');
                WriteRegW <= (others => '0');
            else
                RegWriteW <= RegWriteM;
                MemtoRegW <= MemtoRegM;
                ALUOutW <= ALUOutM;
                ReadDataW <= ReadDataM;
                WriteRegW <= WriteRegM;
            end if;
        end if;
    end Process;
end Behavioral;
