-- mux.vhd
-- Lab 2
-- Team CART
-- CSE 132L
-- This is a 2-to-1 multiplexer, with a generic width for the output and
-- inputs to make the bus size adjustable for each instance.
LIBRARY ieee;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_1164.ALL;
use work.lab2_pack.all;

ENTITY mux IS
	GENERIC(
		NBIT : integer := 32 -- number of bits for input and output
	);
	PORT (
		s : IN std_logic;
		a :	IN std_logic_vector(NBIT-1 DOWNTO 0);
		b :	IN std_logic_vector(NBIT-1 DOWNTO 0);
		o :	OUT std_logic_vector(NBIT-1 DOWNTO 0) 	
	);
END mux;

ARCHITECTURE Behavioral OF mux IS

BEGIN

	WITH s SELECT o <= 
		a WHEN '0', 
		b WHEN '1', 
		(OTHERS => 'X') WHEN OTHERS;

END Behavioral;

