-- mux.vhd
-- Lab 4
-- Team CART
-- CSE 132L
-- This is a 2-to-1 multiplexer, with a generic width for the output and
-- inputs to make the bus size adjustable for each instance.

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;
use work.lab4_pack.all;

entity mux_2 is
generic (
    size : integer := 32 -- number of bits for input and output
);
port (
    s : in std_logic;
    a : in std_logic_vector(size-1 downto 0);
    b : in std_logic_vector(size-1 downto 0);
    o : out std_logic_vector(size-1 downto 0)   
);
end mux_2;

architecture Behavioral of mux_2 is

begin

    with s select
        o <= a when '0', 
             b when '1', 
             (others => 'X') when others;

end Behavioral;

