-- mux.vhd
-- Lab 4
-- Team CART
-- CSE 132L
-- This is a 2-to-1 multiplexer, with a generic width for the output and
-- inputs to make the bus size adjustable for each instance.

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;
use work.lab4_pack.all;

entity mux_4 is
generic (
    size : integer := 32 -- number of bits for input and output
);
port (
    s : in std_logic_vector(1 downto 0);
    a : in std_logic_vector(size-1 downto 0);
    b : in std_logic_vector(size-1 downto 0);
    c : in std_logic_vector(size-1 downto 0);
    d : in std_logic_vector(size-1 downto 0);
    o : out std_logic_vector(size-1 downto 0)   
);
end mux_4;

architecture Behavioral of mux_4 is

begin

    with s select
        o <= a when "00",
             b when "01",
             c when "10",
             d when "11",
             (others => 'X') when others;

end Behavioral;

