-- prog_counter.vhd
-- Lab 2
-- Team CART
-- CSE 132L
-- The program counter block simply increments a count register every
-- clock cycle.
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.lab2_pack.all;

entity prog_counter is
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           output : out  STD_LOGIC_VECTOR (NBIT-1 downto 0));
end prog_counter;

architecture Behavioral of prog_counter is

signal count : unsigned (NBIT-1 downto 0) := (others => '0');

begin

	Process (clk)
	begin
		if (clk'event and clk = '1') then
            if (rst = '1') then
                output <= (others => '0');
                count <= (others => '0');
            else
                output <= std_logic_vector(count);
                count <= count + 1;
            end if;
		end if;
	end Process;

end Behavioral;

