library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.lab5_pack.all;

entity comparator is
port (
    Func_in : in std_logic_vector(NALU-1 downto 0);
    A_in : in std_logic_vector(NBIT-1 downto 0);
    B_in : in std_logic_vector(NBIT-1 downto 0);
    equal : out std_logic
);
end comparator;

architecture Behavioral of comparator is

begin

    equal <= '1' when (Func_in = "111000" and signed(A_in) < 0)
                or (Func_in = "111001" and signed(A_in) >= 0)
                or (Func_in = "111100" and signed(A_in) = signed(B_in))
                or (Func_in = "111101" and signed(A_in) /= signed(B_in))
                or (Func_in = "111110" and signed(A_in) <= 0)
                or (Func_in = "111111" and signed(A_in) > 0)
                else '0';

end Behavioral;
