library IEEE;
use ieee.numeric_std.ALL;
use ieee.std_logic_1164.ALL;
use work.lab5_pack.ALL;

ENTITY execute_memory_reg IS
PORT (
	clk : IN std_logic;
	rst : IN std_logic;
	
	RegWriteE : IN std_logic;
	MemtoRegE : IN std_logic;
	MemWriteE : IN std_logic;
	ALUOutE : IN std_logic_vector(NBIT-1 DOWNTO 0);
	WriteDataE : IN std_logic_vector(NBIT-1 DOWNTO 0);
	WriteRegE : IN std_logic_vector(NREG-1 DOWNTO 0);
	
	RegWriteM : OUT std_logic;
	MemtoRegM : OUT std_logic;
	MemWriteM : OUT std_logic;
	ALUOutM : OUT std_logic_vector(NBIT-1 DOWNTO 0);
	WriteDataM : OUT std_logic_vector(NBIT-1 DOWNTO 0);
	WriteRegM : OUT std_logic_vector(NREG-1 DOWNTO 0)
);
END execute_memory_reg;

ARCHITECTURE Behavorial OF execute_memory_reg IS
BEGIN
	process(clk)
	begin
		if(clk'event and clk = '1') then
			if(rst = '1') then
				RegWriteM <= '0';
				MemtoRegM <= '0';
				MemWriteM <= '0';
				ALUOutM <= (OTHERS => '0');
				WriteDataM <= (OTHERS => '0');
				WriteRegM <= (OTHERS => '0');
            else
            	RegWriteM <= RegWriteE;
            	MemtoRegM <= MemtoRegE;
            	MemWriteM <= MemWriteE;
            	ALUOutM <= ALUOutE;
            	WriteDataM <= WriteDataE;
            	WriteRegM <= WriteRegE;
            end if;
		end if;
	end process;
END Behavorial;
