LIBRARY ieee;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_1164.ALL;
USE work.lab5_pack.ALL;

ENTITY forward IS
PORT (
	RegWriteM : IN std_logic;
	RegWriteW : IN std_logic;
	RsD :       IN std_logic_vector (NREG-1 DOWNTO 0);
	RtD :       IN std_logic_vector (NREG-1 DOWNTO 0);
	RsE :       IN std_logic_vector (NREG-1 DOWNTO 0);
	RtE :       IN std_logic_vector (NREG-1 DOWNTO 0);
	WriteRegM : IN std_logic_vector (NREG-1 DOWNTO 0);
	WriteRegW : IN std_logic_vector (NREG-1 DOWNTO 0);
	
	ForwardAD : OUT std_logic_vector (1 DOWNTO 0);
	ForwardBD : OUT std_logic_vector (1 DOWNTO 0);
	ForwardAE : OUT std_logic_vector (1 DOWNTO 0);
	ForwardBE : OUT std_logic_vector (1 DOWNTO 0)
);
END forward;

ARCHITECTURE Behavorial OF forward IS
BEGIN
	PROCESS(RegWriteM, RegWriteW, RsD, RtD, RsE, RtE, WriteRegM, WriteRegW)
	BEGIN 
		-- generate ForwardAD
		IF (unsigned(RsD) /= 0  and RsD = WriteRegM and RegWriteM = '1') THEN
			ForwardAD <= "10";
		ELSIF (unsigned(RsD) /= 0 and RsD = WriteRegW and RegWriteW = '1') THEN
			ForwardAD <= "01";
		ELSE
			ForwardAD <= "00";
		END IF;
		
		-- generate ForwardBD
		IF (unsigned(RtD) /= 0  and RtD = WriteRegM and RegWriteM = '1') THEN
			ForwardBD <= "10";
		ELSIF (unsigned(RtD) /= 0 and RtD = WriteRegW and RegWriteW = '1') THEN
			ForwardBD <= "01";
		ELSE
			ForwardBD <= "00";
		END IF;

		-- generate ForwardAE
		IF (unsigned(RsE) /= 0  and RsE = WriteRegM and RegWriteM = '1') THEN
			ForwardAE <= "10";
		ELSIF (unsigned(RsE) /= 0 and RsE = WriteRegW and RegWriteW = '1') THEN
			ForwardAE <= "01";
		ELSE
			ForwardAE <= "00";
		END IF;
		
		-- generate ForwardBE
		IF (unsigned(RtE) /= 0  and RtE = WriteRegM and RegWriteM = '1') THEN
			ForwardBE <= "10";
		ELSIF (unsigned(RtE) /= 0 and RtE = WriteRegW and RegWriteW = '1') THEN
			ForwardBE <= "01";
		ELSE
			ForwardBE <= "00";
		END IF;
	END PROCESS;
END Behavorial;
