LIBRARY ieee;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_1164.ALL;
USE work.lab5_pack.ALL;

ENTITY hazard IS
PORT (
    MemtoRegE : IN std_logic;
    MemtoRegM : IN std_logic;
    RsD :       IN std_logic_vector (NREG-1 DOWNTO 0);
    RsE :       IN std_logic_vector (NREG-1 DOWNTO 0);
    RtD :       IN std_logic_vector (NREG-1 DOWNTO 0);
    RtE :       IN std_logic_vector (NREG-1 DOWNTO 0);
    WriteRegE : IN std_logic_vector (NREG-1 DOWNTO 0);
    WriteRegM : IN std_logic_vector (NREG-1 DOWNTO 0);
    BranchD:    IN std_logic;
	JumpD :     IN std_logic;

    FlushE : OUT std_logic;
    StallD : OUT std_logic;
    StallF : OUT std_logic
);
END hazard;

ARCHITECTURE Behavorial OF hazard IS

signal lwstall : std_logic;

BEGIN

    lwstall <= '1' when (MemtoRegE = '1' and (RsD = RtE or RtD = RtE))
                        or (BranchD = '1' and 
						   ((MemtoRegM = '1' and (WriteRegM = RsD or WriteRegM = RtD)) or
						   (RsD = WriteRegE and unsigned(RsD) /= 0) or 
						   (RtD = WriteRegE and unsigned(RtD) /= 0)))
				   else '0';

    FlushE <= '1' when JumpD = '1' else lwstall;
    StallD <= '1' when JumpD = '1' else lwstall;
    StallF <= '1' when JumpD = '1' else lwstall;

--    PROCESS (MemtoRegE, RsD, RsE, RtD, RtE)
--        VARIABLE lwstall : std_logic;
--    BEGIN
--      -- generate FlushE, StallD, StallF
--        IF (((RsD = RtE) or (RtD = RtE)) and MemtoRegE = '1') THEN
--            lwstall := '1';
--        ELSE
--            lwstall := '0';
--        END IF;
--        
--        IF(BranchD = '1') THEN
--            IF(MemToRegM = '1' and (WriteRegM = RsD or WriteRegM = RtD)) THEN
--                lwstall := '1';
--           ELSIF (RsD = WriteRegE or RtD = WriteRegE) THEN
--                lwstall := '1';
--            ELSE
--                lwstall := '0';
--            END IF;
--        END IF;
--
--        FlushE <= lwstall;
--        StallD <= lwstall;
--        StallF <= lwstall;
--    END PROCESS;
END Behavorial;
