-- rom.vhd
-- Lab 3
-- Team CART
-- CSE 132L
-- The ROM component is used for the instrution memory. It has an input port
-- for the address of the instruction to be fetched, and an inout port for
-- the instruction. Here, we use an inout port to be able to preload the
-- instruction memory before reading the instructions. The size of the ROM
-- is 512x32 bits. Initially, we tried using 2^32 lines for the ROM, but
-- we found that both Cadence Incisive and MentorGraphics QuestaSim had
-- issues with a ROM block of that large a size, so we decided to reduce
-- the number of rows to 512, since that would be sufficient for our
-- testing purposes.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library work;
use work.lab5_pack.all;

ENTITY rom IS
	PORT
	(
		addr   : IN std_logic_vector(NBIT-1 DOWNTO 0);
		dataIO : INOUT std_logic_vector(NBIT-1 DOWNTO 0)
	);
END rom;

ARCHITECTURE Behavorial OF rom IS

TYPE mem IS ARRAY (2**(NBIT/2)-1 DOWNTO 0) OF std_logic_vector (NBIT-1 DOWNTO 0);
SIGNAL instr_mem : mem := (others => (others => '0'));

begin
	instr_mem(0) <= 16#20010001#;
	instr_mem(1) <= 16#AC010000#;
	instr_mem(2) <= 16#8C020000#;
	dataIO <= instr_mem(conv_integer(addr(NMEM+2-1 downto 2)));

end Behavorial;
