-- sign_ext.vhd
-- Lab 5
-- Team CART
-- CSE 132L
-- The sign extension unit performs sign extension on the 16-bit immediate
-- value in the instruction to produce a 32-bit value that can be used as
-- the second operand of the ALU.

library ieee;
use ieee.std_logic_1164.all;
use work.lab5_pack.all;

entity sign_ext is
port (
    imm : in std_logic_vector(NIMM-1 downto 0);
    imm_ext : out std_logic_vector(NBIT-1 downto 0)
);
end sign_ext;

architecture Dataflow of sign_ext is

signal extension : std_logic_vector(NBIT-NIMM-1 downto 0);

begin

    extension <= (others => imm(15));
    imm_ext <= extension & imm;

end Dataflow;

