module controller_tb;
    logic[5:0] Func;
    logic[5:0] Op;
    wire[5:0] ALUControl;
    wire ALUSrc;
    wire MemtoReg;
    wire RegWrite;
    wire RegDst;
    wire MemWrite;
    wire Branch;
    
controller C1(
            .Func(Func),
            .Op(Op),
            .ALUControl(ALUControl),
            .ALUSrc(ALUSrc),
            .MemtoReg(MemtoReg),
            .RegWrite(RegWrite),
            .RegDst(RegDst),
            .MemWrite(MemWrite),
            .Branch(Branch)
            );
            
initial begin

    Op = 6'b000000;
    Func = 6'b000000;
    #10;
    
    /* R-type */
    Func = 6'b100000;
    #10;
    Func = 6'b100001;
    #10;
    Func = 6'b100010;
    #10;
    Func = 6'b100011;
    #10;
    Func = 6'b100100;
    #10;
    Func = 6'b100101;
    #10;
    Func = 6'b100110;
    #10;
    Func = 6'b100111;
    #10;
    Func = 6'b101000;
    #10;
    Func = 6'b101001;
    #10;
    Func = 6'b101010;
    #10;
    Func = 6'b101011;
    #10;
    
    
    /* I-type */
    Op = 6'b001000;
    #10;
    Op = 6'b001001;
    #10;
    Op = 6'b001010;
    #10;
    Op = 6'b001011;
    #10;
    Op = 6'b001100;
    #10;
    Op = 6'b001101;
    #10;
    Op = 6'b001110;
    #10;
    
    Op = 6'b001111; /* Invalid - output is 0 */
    #10;
    
    /* lw */
    Op = 6'b100000; /* Invalid - output is 0 */
    #10;
    Op = 6'b100011;
    #10;
    
    /* sw */
    Op = 6'b101000; /* Invalid - output is 0 */
    #10;
    Op = 6'b101011;
    #10;

end
endmodule