module regfile_tb;
  logic clk;
  logic rst_s;
  logic we;
  logic[4:0] raddr_1;
  logic[4:0] raddr_2;
  logic[4:0] waddr;
  wire[31:0] rdata_1;
  wire[31:0] rdata_2;
  logic[31:0] wdata;
  
regfile RF1(
    .clk(clk),
    .rst_s(rst_s),
    .we(we),
    .raddr_1(raddr_1),
    .raddr_2(raddr_2),
    .waddr(waddr),
    .rdata_1(rdata_1),
    .rdata_2(rdata_2),
    .wdata(wdata));
    
always
begin
  #5 clk = 1;
  #5 clk = 0;
end

initial
begin
  /* Initialize clk */
  clk = 0;
  /* Read addresses 0 and 1 */
  rst_s = 0;
  we = 0;
  raddr_1 = 5'b00000;
  raddr_2 = 5'b00001;
  waddr = 5'b00000;
  wdata = 32'b00000000000000000000000000000000;
  #10;
  /* Write to address 1 */
  we = 1;
  waddr = 5'b00001;
  wdata = 32'b00000000000000000101010101010101;
  #10;
  /* Reset */
  we = 0;
  rst_s = 1;
  #10;
  rst_s = 0;
  #10;
  /* Read address 2 */
  raddr_2 = 5'b00010;
  #10;
  /* Attempt to write to address 2 with reset enabled */
  we = 1;
  rst_s = 1;
  wdata = 32'b01010101010101010101010101010101;
  waddr = 5'b00010;
  #10;
  /* Disable reset, keep writing to address 2 */
  rst_s = 0;
  #10;
  we = 0;
  
  //Have to end the testbench else it goes on forever.
  %finish;
end
endmodule
  
